; This script takes a set of layers and apppends a flipped copy of the layers to a copy of the layers, producing a longer looped animation from any animation.

 (define (script-fu-flip-and-stick inImage )
 (let*
    (
		(theImage (car
						(plug-in-animationunoptimize
						 RUN-NONINTERACTIVE
						 inImage
						 inImage
						)
					)
		)
		
		(layers (gimp-image-get-layers theImage))
        (num-layers (car layers))
        (layer-array (cadr layers))
		(i 0)
		(final-layers (* num-layers 2))
		
		(tempLayer ;initialize to type layer, there's probably a better way
				(gimp-layer-new-from-drawable
						(aref layer-array i)
						theImage
				)
		)
	)


	    (while (< i final-layers)
			(set! layer-array (cadr (gimp-image-get-layers theImage)))
			(set! tempLayer 
				(car
					(gimp-layer-new-from-drawable
						(aref layer-array i)
						theImage
					)
				)
			)
			(gimp-item-set-name tempLayer (string-append "Frame " (number->string (+ num-layers (/ i 2)))))
			(gimp-image-insert-layer theImage tempLayer 0 -1)
           (set! i (+ i 2))
         )
	

	(gimp-display-new 
					(car
						(plug-in-animationoptimize
						 RUN-NONINTERACTIVE
						 theImage
						 theImage
						)
					)
	)
 )
)
 
 
  (script-fu-register
    "script-fu-flip-and-stick"                        ;func name
    "Flip-and-Stick"                                  ;menu label
    "This script takes a set of layers and apppends a flipped copy of the layers to a copy of the layers, producing a longer looped animation from any animation."              		;description
    "Ryan Wiedemann"                            ;author
    "released under wtfpl 2014"        ;copyright notice
    "April 17, 2014"                          ;date created
    "*"                     ;image type that the script works on
    SF-IMAGE      "Image"          0   ;an image
	SF-DRAWABLE   "Drawable"       0
  )
 
  (script-fu-menu-register "script-fu-flip-and-stick" "<Image>/Filters/Animation/")
  
 ; This script was created in 2014 by Ryan Wiedemann, released under the following license:

            ; DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    ; Version 2, December 2004

 ; Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>

 ; Everyone is permitted to copy and distribute verbatim or modified
 ; copies of this license document, and changing it is allowed as long
 ; as the name is changed.

            ; DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   ; TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  ; 0. You just DO WHAT THE FUCK YOU WANT TO.
