
(define (fp-script-fu-grungy-photo image layer color merge)


; Declare the Variables

	(let* 
		(
			(copyLayer1(car (gimp-layer-copy layer TRUE)))
			(copyLayer2 (car (gimp-layer-copy layer TRUE)))
			(colorLayer (car (gimp-layer-copy layer TRUE)))
		)
		

(gimp-context-push)
(gimp-undo-push-group-start image)
(gimp-image-add-layer image copyLayer1 -1)
(gimp-drawable-set-name copyLayer1 "Copy of Original Layer")
(gimp-image-add-layer image copyLayer2 -1)
(gimp-layer-set-mode copyLayer2 HARDLIGHT-MODE)
(gimp-drawable-set-name copyLayer2 "Hard Light Mode")
(gimp-layer-set-mode copyLayer2 HARDLIGHT-MODE)
(gimp-drawable-set-name copyLayer2 "Hard Light Mode")
(plug-in-hsv-noise SF-RUN-MODE image copyLayer2 8 0 65 180)
(gimp-levels copyLayer2 0 70 255 2.47 0 255)
(gimp-image-add-layer image colorLayer -1)
(gimp-layer-set-mode colorLayer COLOR-MODE)
(gimp-layer-set-opacity colorLayer 35.0)
(gimp-context-set-foreground color)
(gimp-drawable-fill colorLayer FOREGROUND-FILL)
(gimp-drawable-set-name colorLayer "Filter Color Layer")

(if (= merge TRUE)
	(begin
	(gimp-image-merge-down image colorLayer CLIP-TO-IMAGE)
	(set! copyLayer2 (car (gimp-image-get-active-layer image)))
	(gimp-image-merge-down image copyLayer2 CLIP-TO-IMAGE)
	)
)


(gimp-displays-flush)
(gimp-undo-push-group-end image)
(gimp-context-pop)

)
)



(script-fu-register "fp-script-fu-grungy-photo"
"<Image>/Filters/Decor/Grungy Photo..."
"Create a grungy photo effect based on the Scott Photographics tutorial here: http://www.scottphotographics.com/how-to-make-a-photo-grungy-in-gimp/."
"Art Wade"
"Art Wade"  
"April 2010"
"RGB*"
SF-IMAGE 		"Image" 				0
SF-DRAWABLE 	"Layer" 				0
SF-COLOR 		"Filter Color Layer" 		'(191 141 7)
SF-TOGGLE 		"Merge Layers?" 			FALSE
	
)


